package nl.dancingbear.tunit;

/**
 * Utility class for array modifications.
 *
 * @author Bas Basten
 * @author Anton Lycklama a Nijeholt
 * @date 21-02-2007
 */
public class ArrayUtil {

    /**
     * Concatenate two String arrays.
     *
     * @param firstArray The array that will form the first part of the result.
     * @param secondArray The array that will form the last part of the result.
     * @return An array that contains the items of firstArray and secondArray concatenated.
     * @author Bas Basten
     * @author Anton Lycklama a Nijeholt
     * @date 21-02-2007
     */
    public static String[] concatArrays(String[] firstArray, String[] secondArray) {
        String[] output = new String[firstArray.length + secondArray.length];
        System.arraycopy(firstArray, 0, output, 0, firstArray.length);
        System.arraycopy(secondArray,0, output, firstArray.length, secondArray.length);
        return output;
    }
}
