package nl.dancingbear.tunit;
import java.io.*;

/**
 * This class converts a StackTrace to a String, so that the
 * stack trace of an exception can easily be printed.
 *
 * @author Unknown (http://www.javapractices.com/Topic78.cjp)
 * @date 21-02-2007
 */
public final class StackTraceUtil {

    /**
     * Convert the StackTrace of an Exception to a String.
     *
     * @author Bas Basten & Anton Lycklama a Nijeholt
     * @param aThrowable The Throwable which holds the StackTrace
     * @return A string containing the StackTrace of aThrowable
     * @date 21-02-2007
     */
    public static String getStackTrace(Throwable aThrowable) {
        final Writer result = new StringWriter();
        final PrintWriter printWriter = new PrintWriter(result);
        aThrowable.printStackTrace(printWriter);
        return result.toString();
    }
}
